/* ACTCFG.CPP
   Przykadowa wtyczka dla programu Konnekt...
   Idealny sposb eby zacz pisa co swojego ...

   Przykady:
    -> Wykorzystania tablic ustawie
    -> Wykorzystania okien dialogowych
    -> Obsugi akcji
    -> Obsugi konfiguracji
    -> Obsugi akcji kontaktw
    -> Prostego adowania ikonek

   Powinna zosta skompilowana jako Win32DLL z wykorzystaniem
   wielowtkowej wersji biblioteki CRT!
   Aby zobaczy ikonk, trzeba do skompilowanego projektu doda Resources i do nich
   ikonk (16px x 16px) o identyfikatorze rwnym 100.

   (c)2002 hao | Stamina
   http://www.stamina.eu.org/konnekt/sdk/
*/ 


#include <string.h>
#include <windows.h>
#include "konnekt/plug_export.h"
#include "konnekt/ui.h"
#include "konnekt/plug_func.h"

/*   Definiujemy sobie kilka identyfikatorw z ktrych bdziemy korzysta
   Jako e korzystamy z wartoci sieci rwnej 5, wszystkie identyfikatory
   powinny skada si z 5*1000+warto.
   Najlepiej wszystkie identyfikatory trzyma w osobnym pliku nagwkowym
   np. actcfg_shared.h
   Identyfikatory nie mog si powtarza w swoich "grupach"
*/

#define CFG_EXAMPLE_VALUE 5000  // Pozycja w tablicy konfiguracji
#define IMIG_CFG_EXAMPLE  5000  // Grupa w akcji w konfiguracji
#define IMIA_CFG_EXAMPLE_BUTTON   5001  // Akcja w konfiguracji
#define IMIG_EXAMPLE 5010  // Grupa na gwnym toolbarze
#define IMIA_EXAMPLE_BUTTON  5011  // Akcja w menu na gwnym toolbarze
#define IMIA_CNT_EXAMPLE   5020  // Akcja dla kontaktw
#define IM_EX_TEST 5000 // Identyfikator wiadomoci do wykorzystania przez inne wtyczki...
#define IDI_EXAMPLE  5000            // Identyfikator ikonki
#define IDI_POINT 3 // Ta ikonka jest ju zarejestrowana przez UI. Uwierzcie na sowo :)

#define NET_EXAMPLE 5 // Wartosc net tej wtyczki


int __stdcall DllMain(void * hinstDLL, unsigned long fdwReason, void * lpvReserved)
{
        return true;
}
//---------------------------------------------------------------------------
int Init() {
  /* Do inicjalizowania nie mamy nic... */
  return 1;
}

int DeInit() {
  /* Do usuwania rwnie...
  */
  return 1;
}

int ISetCols() {
  /* Rejestrujemy kolumn w konfiguracji (DTCFG). 
     Niech bdzie to warto tekstowa - czyli DT_CT_STR
	 Dla porzdku nadamy jej te nazw...
     */
    SetColumn(DTCFG , CFG_EXAMPLE_VALUE , DT_CT_STR , "Warto domylna!" , "Example/actcfg/exampleValue");

  return 1;
}

int IPrepare() {
  /* Tutaj rejestrujemy sie w interfejsie.
     Do zarejestrowania mamy 5 akcji i jedn ikonk. 
     Bdziemy korzysta z gotowych funkcji z plug_func.h*/
  /* W tej chwili SDK dysponuje tylko jedn wiadomoci do rejestrowania ikonek.
     W nastpnej edycji SDK powinny pojawi si wiksze moliwoci... */
	IconRegister(IML_16 , IDI_EXAMPLE // ID rejestrowanej ikonki
		, Ctrl->hDll() // uchwyt do wtyczki
		, 100 // Identyfikator tej ikonki w zasobach wtyczki...
		);

  /* Rejestrujemy akcje ktre bd widoczne na toolbarze w oknie gwnym.

     Najpierw rejestrujemy grup, ktr dodajemy do grupy IMIG_MAINTB.
     W ten sposb tworzymy now ikonk na toolbarze.
     Wstawiamy j na drug pozycj od lewej.
  */
  UIGroupInsert(IMIG_MAINTB  // Grupa - matka
       , IMIG_EXAMPLE        // ID nowej grupy
       , 1                   // Pozycja do wstawienia. 0 - pocztek -1 - koniec
       , 0                   // Status akcji. Powinnimy poda ACTS_GROUP, ale UIGroupInsert robi to ju za nas...
       , "Przykad"          // Tre akcji. W tym wypadku zawarto tooltipa
       , IDI_POINT         // jako P1 w menusach podajemy ID ikonki
       ); // Reszt parametrw moemy sobie darowa. Wszystkie i tak s rwne 0!
  /* Dodajemy akcj */
  UIActionAdd(IMIG_EXAMPLE // Wstawiamy do utworzonej ju grupy
      , IMIA_EXAMPLE_BUTTON
      , 0
      , "Wcinij mnie!"
      , IDI_EXAMPLE // Identyfikator naszej ikonki z zasobw wtyczki
      );
  /* Dodajemy akcj do menu kontaktw. Dodatkowo zrobimy tak, aby pojawiaa sie tylko przy
     kontaktach bez sieci!*/
  UIActionAdd(IMIG_CNT // Menu kontaktw
      , IMIA_CNT_EXAMPLE // ID akcji
      , ACTR_INIT              // Rzdamy powiadomienia o utworzeniu pozycji w menu
      , "Jestem spoza sieci!"
      , IDI_EXAMPLE
      );
  /* wietnie, dodajmy teraz akcje do konfiguracji */
  /* Najpierw tworzymy grup */
  UIGroupAdd(IMIG_CFG  // Grupa - matka
       , IMIG_CFG_EXAMPLE        // ID nowej grupy
       , 0                   // Status akcji. Powinnimy poda ACTS_GROUP, ale UIGroupInsert robi to ju za nas...
       , "Przykad!"          // Tre akcji. W tym wypadku zawarto tooltipa
       , IDI_POINT         // jako P1 w grupach konfiguracji podajemy ID ikonki
       ); // Reszt parametrw moemy sobie darowa. Wszystkie i tak s rwne 0!
  /* Teraz robi si ciut ciekawiej. Najpierw dodajmy krtki opis. Nie potrzebujemy do tego
     identyfikatora bo i tak nic z nim nie bdziemy robi.
     Funkcja UIActionCfgAdd przydaje si TYLKO gdy chcemy przesun kontrolk wzgldem osi x lub y.
     Spokojnie mona uyc UIActionAdd ...
     */
  /* Dobr 'manier' w konfiguracji jest grupowanie kontrolek... a wic */
  UIActionAdd(IMIG_CFG_EXAMPLE , 0 , ACTT_GROUP , "Przykad z actcfg.cpp");
    UIActionCfgAdd(IMIG_CFG_EXAMPLE  // Grupa - matka
        , 0        
        , ACTT_INFO           // Status akcji. Podajemy ACTT_INFO jako typ wstawianej kontrolki...
        , "Wpisz poniej dowolny tekst.\n\nJeeli wpiszesz \"aa\" stanie si co dziwnego!"          // Tre informacji.
        , IDI_POINT         // jako P1 w menusach podajemy ID ikonki
        ,0,0  // Przesunicie wzgldem x i y zostawiamy w spokoju...
        ,100  // Szeroko. ACTT_INFO jest rozcigany na ca szeroko. Nie ma znaczenia co tutaj wpiszemy
        ,40   // Wysoko. Niech nasze info ma 40 pixeli wysokoci... 
        ); // Reszt parametrw moemy sobie darowa. Wszystkie i tak s rwne 0!
    /* Teraz dodamy kontrolk przy pomocy ktrej moemy edytowa nasz kolumn CFG_EXAMPLE_VALUE.
       UI automatycznie zajmuje si konwersj typw i adowaniem/zapisywaniem. My za to
       bdziemy sprawdza, czy to co jest wpisywane, wpisywane jest poprawnie... */
    UIActionCfgAdd(IMIG_CFG_EXAMPLE  // Grupa - matka
        , IMIB_CFG   /* Ustawiajc identyfikator w ten sposb mamy pewno, e faktycznym identyfikatorem akcji 
                        bdzie IMIB_CFG|P1, gdzie P1 zaraz stanie si identyfikatorem kolumny.
                     */
        , ACTT_EDIT|ACTSC_INLINE|ACTR_CHECK  /* ACTT_EDIT to kontrolka do edycji. Dziki ACTSC_INLINE nastpna
                                               kontrolka pojawi si w tej samej linijce...
                                               Dziki ACTR_CHECK zostaniemy powiadomieni o zmianach
                                               w tej kontrolce!
                                               */
        , "" CFGTIP "Sprbuj wpisa 'aa'!"  // Wszystko co jest po CFGTIP pjdzie do ToolTip'a!
        , CFG_EXAMPLE_VALUE // jako P1 w konfiguracji podajemy kolumn w tablicy CFG przypisan do
                          // do danej kontrolki. Podczas zapisywania, warto kontrolki zostanie
                          // zapisana w odpowiedniej kolumnie...  
        ,10,0  // Zrbmy mae wcicie...
        ,50  // Szeroko.
        ,0   // Wysokoci zajmie si automat...
        ); // Reszt parametrw moemy sobie darowa. Wszystkie i tak s rwne 0!
  /* Moe swko komentarza? */
  UIActionAdd(IMIG_CFG_EXAMPLE , 0 , ACTT_COMMENT , "<- tutaj wpisuj!");
  /* Zosta nam jeszcze button */
  UIActionAdd(IMIG_CFG_EXAMPLE , IMIA_CFG_EXAMPLE_BUTTON , ACTT_BUTTON , "Kliknij mnie!",0,120,40);
  /* Otwart grup koniecznie trzeba zamkn! */
  UIActionAdd(IMIG_CFG_EXAMPLE , 0 , ACTT_GROUPEND);

  return 1;
}

int IStart() {
  /* Tutaj wtyczk uruchamiamy. W tym wypadku Konnekt robi wszystko za nas :) */

  return 1;
}
int IEnd() {
  /* Tutaj wtyczk wyczamy */
  return 1;
}


int ActionCfgProc(sUIActionNotify_base * anBase) {
  sUIActionNotify_2params * an = (anBase->s_size>=sizeof(sUIActionNotify_2params))?static_cast<sUIActionNotify_2params*>(anBase):0;
  /* Tutaj obsugujemy akcje dla okna konfiguracji */ 
  switch (anBase->act.id & ~IMIB_CFG) {
       case CFG_EXAMPLE_VALUE:
           if (anBase->code == ACTN_CHECK) {
               /* Sprawdzamy zawarto kontrolki. Jej aktualna warto znajduje si notify1 */
               static char value [3] = "bb";
               if (!strcmp((char*)an->notify1 , "aa")) { // sprawdzamy czy wpisalimy 'aa'
                   an->notify1 = (int)value; // jak tak - zmieniamy na bb
                   /* Ze wzgldu na pewn "niedoskonao" ktr odkryem piszc ten
                      kod TRZEBA zmieni an->notify1 na inny bufor (ktry musi by
                      wany rwnie po opuszczeniu tej funkcji) eby zmieni warto kontrolki.
                      W nastpnej wersji programu bd bdzie poprawiony...
                      
                      ACTN_CHECK przysyany jest w tej chwili TYLKO do kontrolek z polem edycji...*/
               }

           }
           break;
  }
  return 0;
}

ActionProc(sUIActionNotify_base * anBase) {
  sUIActionNotify_2params * an = (anBase->s_size>=sizeof(sUIActionNotify_2params))?static_cast<sUIActionNotify_2params*>(anBase):0;
  /* Tutaj obsugujemy akcje */ 
  if ((anBase->act.id & IMIB_) == IMIB_CFG) return ActionCfgProc(anBase); 
  switch (anBase->act.id) {
       case IMIA_CFG_EXAMPLE_BUTTON: {
           ACTIONONLY(anBase); // Dziki temu obsuymy tu tylko ACTN_ACTION, czyli nacinicie buttona
           /* Wywietlimy sobie okno dialogowe do wprowadzania tekstu */
           sDIALOG_enter sde;
           sde.info = "Wpisz co chciaby ujrze w kontrolce edycji?";
           sde.title = "actcfg.cpp";
           /* jako warto pocztkow wemiemy to, co jest wpisane w pole edycji
              eby tego dokona musimy wywoa odpowiedni f-cj...
              Jak wida jej parametrem jest deskryptor akcji.
              Trzeba w nim poda identyfikator grupy i akcji o ktr nam chodzi...
           */
           char buff [200];
           buff[199]=0;
           UIActionCfgGetValue(sUIAction(IMIG_CFG_EXAMPLE , IMIB_CFG|CFG_EXAMPLE_VALUE),buff,200);
           sde.value = buff;
           ICMessage(IMI_DLGENTER , (int)&sde);
           /* Wpisan warto wrzucamy do kontrolki */
           /* Uwaga! Nacinicie w okienku na Cancel ustawia value na 0!!! */
           if (sde.value) UIActionCfgSetValue(sUIAction(IMIG_CFG_EXAMPLE , IMIB_CFG|CFG_EXAMPLE_VALUE),sde.value);
           break;}
       case IMIA_EXAMPLE_BUTTON: {
           ACTIONONLY(anBase);
           /* Pobierzemy sobie warto naszej kontrolki i j wywietlimy
              Najpierw jednak zapytamy uytkownika w jakim oknie chce zobaczy wynik... */
           sDIALOG_choose sdc;
           sdc.def = 1;
           sdc.info = "Wybierz jak przedstawi warto?";
           sdc.title = "actcfg.cpp";
           sdc.items = "IMI_INFORM\nIMI_ERROR"; /* Kada linijka to nowy button */
           char buff [200];
           strncpy(buff , GETSTR(CFG_EXAMPLE_VALUE) , 200); // Pobieramy warto
           switch (ICMessage(IMI_DLGBUTTONS , (int)&sdc)) {
               case 1: return ICMessage(IMI_INFORM , (int)buff); // Wybralimy opcj pierwsz
               case 2: return ICMessage(IMI_ERROR , (int)buff);
               default: return ICMessage(IMI_INFORM , (int)"Nie to nie..."); // Cancel
           }
           break;}
       case IMIA_CNT_EXAMPLE: {  // Akcja w menu kontaktw
           if (anBase->code == ACTN_CREATE) {
               /* Reagujemy na otworzenie menu. Moemy sprawdzi czy kontakt jest z jakiej sieci.
                  an to sUIActionNotify, czyli powiadomienie o zdarzeniu w akcji.
                  eby sprawdzi z jakim kontaktem powizana jest teraz akcja, trzeba sprawdzi
                  jej deskryptor, ktry znajduje si w an->act...
               */
               bool ok = GETCNTI(an->act.cnt , CNT_NET) == NET_NONE;
               sUIActionInfo ai;   // Zmienimy status kontrolki
               ai.act = an->act;  // Chodzi nam o t sam dla ktrej wywoane jest powiadomienie prawda?
               ai.mask = UIAIM_STATUS;      // Zmianiamy status
               ai.status = ok?0:ACTS_HIDDEN;
               ai.statusMask = ACTS_HIDDEN; // Zmieniamy tylko ten jeden bit statusu
               if (ok) { // eby byo mieszniej bdziemy zmienia jeszcze opis tekstowy...
                   bool desc = false;
                   char * d1 = "Jestem bez sieci i jestem z tego dumny!";
                   char * d2 = "Ja chc nalee do sieeeeciiiii!";
                   ai.mask |= UIAIM_TXT; // Zmieniamy jeszcze text
                   ai.txt = desc?d2:d1;    // wybieramy tekst...
                   desc=!desc;
               }
               ICMessage(IMI_ACTION_SET , (int)&ai); // Gotowe!
           } else if (anBase->code == ACTN_ACTION) {
               /* Na koniec zasymulujemy dug operacj... */
               sDIALOG_long sdl;
               sdl.title = "actcfg.cpp";
               sdl.info = "Przyczanie do sieci...";
               char * t [4]={"cz","przyczam","zaczam","rozczam"};
               sdl.flag = DLONG_BLOCKING ;
               /* UWAGA! Okazao si e w API jest bd, ktry przy Blokujcych dugich operacjach
               objawia si tym, e w oknie z progresem bdzie nieodwieony prostokt...
               Postaram si usun problem w nowszej wersji... :) */
               ICMessage(IMI_LONGSTART , (int)&sdl); // zaczynamy
               for (int i=0; i<4; i++) {
                   for (int j=0; j<100; j++)
                     SleepEx(10,TRUE); // ZAWSZE uywamy komend czekajcych z EX jeli jestemy w gwnym wtku!
                                        // Powtarzam operacj, poniewa proces odwieania okienka bdzie zrywa SleepEx
                   sdl.progress += 25;
                   sdl.info = t[i];
                   ICMessage(IMI_LONGSET , (int)&sdl, DSET_PROGRESS|DSET_INFO);   // koczymy
                   
               }
                   for (int j=0; j<50;j++)
                     SleepEx(10,TRUE); 
               ICMessage(IMI_LONGEND , (int)&sdl);   // koczymy

           }
           break;}
  }
  return 0;
}



int __stdcall IMessageProc(sIMessage_base * msgBase) {
 sIMessage_2params * msg = (msgBase->s_size>=sizeof(sIMessage_2params))?static_cast<sIMessage_2params*>(msgBase):0;
 switch (msgBase->id) {    /* Wiadomoci na ktre TRZEBA odpowiedzie */
    case IM_PLUG_NET:        return NET_EXAMPLE; // Zwracamy warto sieci jako NET_EXAMPLE
    case IM_PLUG_TYPE:       return IMT_UI|IMT_CONTACT|IMT_CONFIG; // Ta wtyczka obsuguje UI, kontakty i Config...
    case IM_PLUG_VERSION:    return (int)""; // 
    case IM_PLUG_SDKVERSION: return KONNEKT_SDK_V;  // Ta linijka jest wymagana!
    case IM_PLUG_SIG:        return (int)"EX2"; // Sygnaturka wtyczki (krtka, kilkuliterowa nazwa)
    case IM_PLUG_CORE_V:     return (int)"W98"; // Wymagana wersja rdzenia
    case IM_PLUG_UI_V:       return 0; // Wymagana wersja UI
    case IM_PLUG_NAME:       return (int)"actcfg.cpp"; // Pena nazwa wtyczki
    case IM_PLUG_NETNAME:    return 0; // Nazwa obsugiwanej sieci (o ile jak sie obsuguje)
    case IM_PLUG_INIT:       Plug_Init(msg->p1,msg->p2);return Init();
    case IM_PLUG_DEINIT:     Plug_Deinit(msg->p1,msg->p2);return DeInit();

    case IM_SETCOLS:     return ISetCols();

    case IM_UI_PREPARE:      return IPrepare();
    case IM_START:           return IStart();
    case IM_END:             return IEnd();

    /* Obsuymy jeszcze IM_EX_TEST. Jeli uyjemy wtyczki msgs.cpp razem z t
       powinimy zobaczy efekt ich wsppracy :) */
    case IM_EX_TEST:         ICMessage(IMI_NOTIFY , (int)"ACTCFG @ IM_EX_TEST");return 1;
    case IM_UIACTION:        return ActionProc((sUIActionNotify_base*)msg->p1);

    /* Tutaj obsugujemy wszystkie pozostae wiadomoci */


 }
    if (Ctrl) Ctrl->setError(IMERROR_NORESULT);
    return 0;
}


/*

  To wszystko z nowoci... Jak widzicie, po usuniciu komentarzy a tak duo nie jest, 
  a myl e jest dosy prosto...

  Zapraszam do nastpnego tutoriala :)

*/
