/* MSGS.CPP
   Przykadowa wtyczka dla programu Konnekt...
   Idealny sposb eby zacz pisa co swojego ...

   Przykady:
    -> wprowadzanie wiadomoci do kolejki
    -> obsuga wiadomoci
    -> sprawdzanie kolejki wiadomoci

   Jest to bardzo prosty przykad wykorzystania kolejki wiadomoci...
   By moe w nastpnych edycjach SDK zostanie on rozszerzony...

   Powinna zosta skompilowana jako Win32DLL z wykorzystaniem
   wielowtkowej wersji biblioteki CRT!

   (c)2002 hao | Stamina
   http://www.stamina.eu.org/konnekt/sdk/
*/ 

#include <memory.h>
#include <stdio.h>
#include "konnekt/plug_export.h"
#include "konnekt/ui.h"
#include "konnekt/plug_func.h"


#define IMIG_EXAMPLE 5100
#define IMIA_EXAMPLE_MGG 5101
#define IMIA_EXAMPLE_MSG 5102
#define IM_EX_TEST 5000 // Identyfikator wiadomoci ktry wylemy do actcfg.cpp
#define MT_EXAMPLE 500
#define NET_EXAMPLE 5 // Wartosc net tej wtyczki
int __stdcall DllMain(void * hinstDLL, unsigned long fdwReason, void * lpvReserved)
{
        return true;
}
//---------------------------------------------------------------------------
/* Wszystkie ponisze funkcje nie s wymagane (z wyjtekim IMEssageProc)...
   ale z nimi wszystko wyglda czytelniej :)
*/

int IPrepare() {
  /* Tutaj rejestrujemy sie w interfejsie */
  /*Mowa bya ju o tym w actcfg.cpp wic nie bd si powtarza... Tym razem stworzymy sobie osobny toolbar!*/
  UIGroupAdd(IMIG_BAR , IMIG_EXAMPLE , 0,"msgs.cpp");
  UIActionAdd(IMIG_EXAMPLE , IMIA_EXAMPLE_MSG , 0 , "MSG",UIIcon(IT_MESSAGE,0,MT_SERVEREVENT,0),40,40); // Ta akcja wstawi do kolejki "nasz" wiadomo...
  UIActionAdd(IMIG_EXAMPLE , IMIA_EXAMPLE_MGG , 0 , "GG",UIIcon(IT_MESSAGE,0,MT_MESSAGE,0),40,40); // a ta wrzuci wiadomo od kontaktu z UID 1 na GG 
                                 // pamitaj eby wczy przyjmowanie wiadomoci od osb spoza listy!
  return 1;
}

ActionProc(sUIActionNotify_base * anBase) {
  sUIActionNotify_2params * an = (anBase->s_size>=sizeof(sUIActionNotify_2params))?static_cast<sUIActionNotify_2params*>(anBase):0;
  /* Tutaj obsugujemy akcje */ 
  switch (anBase->act.id) {
       case IMIA_EXAMPLE_MGG:{
           ACTIONONLY(anBase);
           cMessage m;
           memset(&m , 0 , sizeof(m));
           m.flag = MF_HANDLEDBYUI; // Wiadomo zostanie obsuona w caoci przez UI
           m.fromUid = "1";
           m.toUid = ""; // Wiadomo ma przyj, czyli jest do nas, czyli nie wpisujemy nic...
           m.net = NET_GG;
           m.time = 0; // Czas podajemy w formacie cTime64 - jest to mj wasny format  i udostpnie
              // obsugujc go bibliotek razem z nastpnym SDK...
              // Format jest podobny jak tm co do iloci pl, tyle e upycha je wszystkie w 64 bitach...
              // Nie zastosowaem zwykego time_t bo jest dosy "krtki" , a time64_t obsuguje tylko MSVC ...
           m.type = MT_MESSAGE;
           m.body = "HELLO WORLD!"; // Tre
           m.ext = ""; // Dodatkowe info... na razie pusto
           sMESSAGESELECT ms;
           ms.id = ICMessage(IMC_NEWMESSAGE , (int)&m);
           // w ms.id dostalimy ID dodanej wiadomoci...
           // po dodaniu wiadomoci ZAWSZE trzeba przejrze kolejk...
           // w sMESSAGESELECT podajemy jakie wiadomoci doszy...
           // ustawiajc tylko ms.id MessageQueue zostanie sprawdzone pod ktem tylko tej jednej
           // wiadomoci... Trzeba jednak sprawdzi czy wiadomo zostaa w ogle dodana do
					 // kolejki...
           if (ms.id) ICMessage(IMC_MESSAGEQUEUE , (int)&ms);
           break;}
       case IMIA_EXAMPLE_MSG:{
           ACTIONONLY(anBase);
           cMessage m;
           memset(&m , 0 , sizeof(m));
           m.flag = 0; // Wiadomo zostanie obsuona w caoci przez UI
           m.fromUid = "msgs.cpp";
           m.toUid = ""; // Wiadomo ma przyj, czyli jest do nas, czyli nie wpisujemy nic...
           m.net = NET_EXAMPLE;
           m.time = 0; 
           m.type = MT_EXAMPLE | MT_MASK_NOTONLIST; // Nasz typ wiadomoci... MT_MASK_NOTONLIST oznacza, e rdze nie sprawdzi od kogo przysza wiadomo...
           m.body = "HELLO WORLD!"; // Tre
           m.ext = ""; // Dodatkowe info... na razie pusto
           ICMessage(IMC_NEWMESSAGE , (int)&m);
           /* Teraz zostanie wywoane IM_MSG_RCV na ktry zwrcimy IM_MSG_delete...
              Wywoywanie IMC_MESSAGEQUEUE nie ma wic sensu...

              Pena obsuga wiadomoci, cznie z oczekiwaniem na odbir wymagaaby
              zwrcenia IM_MSG_ok przy zapytaniu IM_MSG_RCV, co przydzielioby wiadomo
              do naszej wtyczki, a nastpnie obsugi IM_MSG_OPEN ktrego mechanizm
              najlepiej rozwiza w sposb taki:
                (Dla uproszczenia zamy e wiadomo jest wiadomoci "od serwera", czyli
                 e nie pojawi si na licie kontaktw...)
                - w IM_MSG_OPEN sprawdzamy czy jest utworzone okno, w ktrym ma pojawi si wiadomo
                   tak -> wypisujemy wiadomo w oknie i zwracamy IM_MSG_delete
                   nie -> zwracamy 0...
                - w odpowiedzi na nasz akcj np. "odbierz wiadomo" tak na prawd tworzymy tylko
                  okno i wywoujemy IMC_MESSAGEQUEUE ... Mona oczywicie te przejrze list rcznie...
                  jak kto woli...
              */

           break;}
  }
  return 0;
}



int __stdcall IMessageProc(sIMessage_base * msgBase) {
 sIMessage_2params * msg = (msgBase->s_size>=sizeof(sIMessage_2params))?static_cast<sIMessage_2params*>(msgBase):0;
 switch (msgBase->id) {
    /* Wiadomoci na ktre TRZEBA odpowiedzie */
    case IM_PLUG_NET:        return NET_EXAMPLE; // Zwracamy warto NET, ktra MUSI by rna od 0 i UNIKATOWA!
    case IM_PLUG_TYPE:       return IMT_UI|IMT_MESSAGE|IMT_MSGUI; // Zwracamy jakiego typu jest nasza wtyczka (ktre wiadomoci bdziemy obsugiwa)
    case IM_PLUG_VERSION:    return (int)""; // Wersja wtyczki tekstowo ...
    case IM_PLUG_SDKVERSION: return KONNEKT_SDK_V;  // Ta linijka jest wymagana!
    case IM_PLUG_SIG:        return (int)"EX3"; // Sygnaturka wtyczki (krtka, kilkuliterowa nazwa)
    case IM_PLUG_NAME:       return (int)"msgs.cpp"; // Pena nazwa wtyczki
    case IM_PLUG_NETNAME:    return 0; // Nazwa obsugiwanej sieci (o ile jak sie obsuguje)
    case IM_PLUG_INIT:       Plug_Init(msg->p1,msg->p2);return 1; // Zawsze musi zwrci 1!
    case IM_PLUG_DEINIT:     Plug_Deinit(msg->p1,msg->p2);return 1;


    case IM_UI_PREPARE:      return IPrepare();

    case IM_UIACTION:        return ActionProc((sUIActionNotify_base*)msg->p1);

    /* Rdze odpytuje kolejne wtyczki czy bd obsugiway dan wiadomo...
       Jeeli nie zamierzamy - zwracamy 0...
       Moemy rwnie otworzy j od razu i skasowa zwracaj IM_MSG_delete co
       wanie tutaj robimy...*/
    case IM_MSG_RCV:{
        cMessage * m = (cMessage*)msg->p1;
        /* Bierzemy tylko wiadomo "naszego" typu */
        if (m->type == (MT_EXAMPLE | MT_MASK_NOTONLIST)) {
            char buff [200];
            sprintf(buff , "Dostaem wiadomo od %s:\n\n%s" , m->fromUid , m->body);
            ICMessage(IMI_INFORM , (int)buff);
            return IM_MSG_delete;
        }
        return 0;}

    /* Tutaj obsugujemy wszystkie pozostae wiadomoci */


 }
    if (Ctrl) Ctrl->setError(IMERROR_NORESULT);
    return 0;
}

