/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: GG API
 * Modyfikowany: 2004-09-27
 * Zgodny z wersj: 1.1
 * Info: Nagwek wtyczki GG.
 * 
 * rodowisko: Borland C++ i MS Visual C++
 * 
 * http://www.stamina.eu.org/konnekt/sdk/
 * 
 * (C)2002-2003 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */



/** @file Nagwek wtyczki GG.DLL 


*/
/** @defgroup GG_shared_h Wtyczka GG.dll.

W API od wersji 1.1 znajduje si obsuga zdarze w libgadu. 
Potrzebne bd rwnie przynajmniej nagwki libgadu, ktre dostpne jest do pobrania
na stronie domowej SDK.

Poniszy przykad powinien wszystko wyjani...
@code
    #include "gg_shared.h"
    // (...)
	// Gdzie w kodzie "rejestrujemy" nasz wtyczk. Np. w #IM_START
	IMessage(IM_GG_REGISTERHANDLER,NET_GG,IMT_PROTOCOL,GGER_LOGIN|GGER_EVENT);
	// Dziki GGER_LOGIN bdziemy mogli zmieni parametry logowania do 
	// poszczeglnych serwerw, a GGER_EVENT przyle kad odpowied serwera.
	// Moliwoci jest jeszcze kilka...

	// W IMessageProc musimy jeszcze obsuy #IM_GG_EVENT
	case IM_GG_EVENT: {
		sIMessage_GGEvent * me = static_cast<sIMessage_GGEvent*>(msgBase);
		// W zalenoci od typu zdarzenia wykonujemy rne operacje
		switch (me->event_type) {
		    // (...)
		}
		break;}
	// Jeeli bdziemy chcieli gdzie w kodzie skorzysta z sesji libgadu to:
	gg_session * sess = IMessage(IM_GG_GETSESSION,NET_GG,IMT_PROTOCOL); // Pobieramy sesj
	if (sess) {
		// (...) operacje na sesji z wykorzystaniem libgaduw32.dll
		// Kad pobran sesj TRZEBA zwolni, ale TYLKO gdy zwrcona sesja jest != 0
		IMessage(IM_GG_RELEASESESSION,NET_GG,IMT_PROTOCOL);
	}
@endcode    
@{
*/

#pragma pack(push, 1)

/** Zwraca wskanik do sesji libgadu (gg_session) lub 0
    gdy nie ma ustanowionego poczenia. Po zakoczeniu
	operowania na sesji trzeba wywoa #IM_GG_RELEASESESSION.
	
	Do samego sprawdzania istnienia poczenia najlepiej posuy
	#IM_ISCONNECTED.

	@return (gg_session*) Wskanik sesji.
	*/
#define IM_GG_GETSESSION IM_USER+10001 
/** Zwalnia pobrany wczeniej wskanik sesji... */
#define IM_GG_RELEASESESSION IM_USER+10002

/** Wtyczka bdzie otrzymywaa powiadomienia przy wybranych
    zdarzeniach w libgadu.

	@param (int) poczone flagi GGER_ oznaczajce o jakich zdarzeniach wtyczka powinna by powiadamiana.
*/
#define IM_GG_REGISTERHANDLER IM_USER+10003

enum GGER_enum {
   GGER_LOGIN = 1, ///< Zaraz przed nawizaniem poczenia. Mona je anulowa przez GGERF_ABORT
   GGER_LOGGEDIN = 2, ///< Udane logowanie
   GGER_LOGOUT = 4, ///< Zakoczenie poczenia
   GGER_EVENT = 8, ///< Zdarzenie sieciowe
   GGER_FIRSTLOOP = 0x10, ///< Po zalogowaniu i przesaniu wszystkich informacji (lista kontaktw, status itp.)
   GGER_BEFORELOGIN = 0x20, ///< Zaraz przed rozpoczciem procedury logowania (i przed okreleniem IP serwera)
   GGER_BEFORELOGOUT = 0x40, ///< Zaraz przed zakoczeniem poczenia (nie zostanie wywoane w razie zerwania poczenia)
};

#define GGERF_ABORT 1  ///< Przerwanie obsugiwania Eventu...
/** Wtyczka, ktra zarejestrowaa si jako handler otrzyma
    ten komunikat w razie wystpienia ktrego z "zamwionych"
	zdarze. Komunikat bdzie typu sIMessage_GGEvent.

	@return Poczone flagi GGERF_ , lub 0.
*/
#define IM_GG_EVENT IM_USER+10100

/** Struktura do przesyania IM_GG_EVENT */
struct sIMessage_GGEvent: public sIMessage_base {
	GGER_enum eventType;   ///< Typ zdarzenia - jedna z flag GGER_
	/** W zalenoci od typu zdarzenia w data
	    przekazywana jest odpowiednia strukturka, lub 0.
		Wikszo przekazywanych struktur mona modyfikowa.
		Zdarzenia najczciej wywoywane s PRZED wykonaniem
		samej operacji...
		*/
	union {
       struct gg_login_params * login_params; ///< Parametry logowania [GGER_LOGIN , GGER_BEFORELOGIN]
	   struct gg_event * event; ///< Zdarzenie sieciowe [GGER_EVENT]
	   void * pointer;
	} data;
	sIMessage_GGEvent()
		:sIMessage_base() {s_size=sizeof(sIMessage_GGEvent);}
};


#define CFG_GG_LOGIN    1053
#define CFG_GG_PASS     1054
#define CFG_GG_STATUS   1055 //INT 
#define CFG_GG_STARTSTATUS 1056 //INT
#define CFG_GG_DESCR   1057 //INT
#define CFG_GG_SERVER  1059  
#define CFG_GG_SERVERCHOSEN  1060
#define CFG_GG_TRAYMENU 1061

#define CFG_GG_FRIENDSONLY 1058  //INT
#define CFG_GG_USESSL  1063
#define CFG_GG_DONTRESUMEDISCONNECTED 1064

#define IMIA_GGSTATUS_OFFLINE 1001
#define IMIA_GGSTATUS_ONLINE 1002
#define IMIA_GGSTATUS_AWAY 1003
#define IMIA_GGSTATUS_HIDDEN 1004
#define IMIA_GGSTATUS_DESC   1005

#define IMIG_GGSTATUS_SERVER 1020

#define IMIG_MAIN_OPTIONS_LIST_GG 1010
#define IMIA_LIST_GG_IMPORT 1011
#define IMIA_LIST_GG_EXPORT 1012
#define IMIA_LIST_GG_CLEAR  1013
#define IMIA_LIST_GG_REFRESH 1014

#define IMIA_GGHIDESTATUS 1015

#define IMIA_NFO_GGSAVE   1022
#define IMIA_NFO_GGREFRESH   1021


#define IMIG_GGSTATUS 1000

#define IMIG_GGCFG_USER 1050
#define IMIC_GG_ACCOUNT  1051
#define IMIC_GG_NEWPASS  1052
#define IMIC_GG_REMINDPASS 1053
#define IMIC_GG_DEFSERVERS 1054
#define IMIC_GG_REMOVEACCOUNT  1055
#define IMIC_GG_SERVERSSSLONLY 1056
//#define IMIC_GG_PORT  1052
//#define IMIC_GG_LOGIN  1053
//#define IMIC_GG_PASS  1054

#pragma pack(pop)

/**@}*/