/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: kSound API
 * Modyfikowany: 2004-09-27
 * Zgodny z wersj: 
 * Info: Nagwek wtyczki kSound.
 * 
 * rodowisko: Borland C++ i MS Visual C++
 * 
 * http://www.stamina.eu.org/konnekt/sdk/
 * 
 * (C)2002-2003 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */

/** @file Nagwek wtyczki kSound


*/
/** @defgroup SOUND_shared_h Wtyczka kSound.dll.

 kSound odpowiada za odtwarzanie dwikw. 
 Przy pomocy kSound::SoundRegister() mona doda
 nowy dwik do listy, a nastpnie go odtworzy przez
 kSound::SoundPlay().

 @warning kSound::SoundRegister() moe by wywoany @b tylko
  w momencie otrzymania przez wtyczk komunikatu
  kSound::DOREGISTER .
  DOREGISTER wywoywane jest dwukrotnie. Podczas rejestrowania kolumn i tworzenia
  interfejsu.
  Za kadym razem trzeba zarejestrowa TE SAME dwiki!

 Kolumny w konfiguracji nazywane s jako "SOUND_" + nazwa_dwiku.
 Akcje w konfiguracji maj identyfikatory (@a id - ID kolumny z dwikiem):
   kSound::action::Check | id - Checkbox
   kSound::action::Value | id - Warto
   kSound::action::Play | id - Play/Stop
 @{
*/
namespace kSound {
	const int REGISTER = IM_USER + 3000;
	const int PLAY = IM_USER + 3001;
	const int DOREGISTER = IM_USER + 3002;
	/** Struktura do wysania razem z kSound::SOUND_REGISTER
	*/
	class sIMessage_SoundRegister: public sIMessage_base {
	public:
		int colID; ///< konkretny identyfikator kolumny, lub -1
		const char * name; ///< Jednoznaczna nazwa dwiku (nazwa kolumny w konfiguracji i pola w XMLu)
		const char * info; ///< Informacja przy polu w konfiguracji.
		int flags; ///< Flagi kSound::flags .
		sIMessage_SoundRegister(const char * name , const char * info , int flags = 0 , int colID = -1):sIMessage_base(REGISTER) , colID(colID),name(name),info(info),flags(flags) {
			s_size = sizeof(*this);
			net = NET_SOUND;
			type = IMT_CONFIG;
		}
	};
	namespace flags {
		const char contacts=1; ///< Dla kadego kontaktu przechowywane jest osobne ustawienie.
		const char no_column_register=2; ///< kSound nie zarejestruje kolumny w konfiguracji.
		const char no_action_register=4; ///< kSound nie utworzy akcji...
	};
	namespace action {
		const int Check = 0x1A000000;
		const int Play =  0x1B000000;
		const int Value = 0x1C000000;
		const int mute = NET_SOUND * 1000 + 20;
	};
	namespace Cfg {
		const int mute = NET_SOUND * 1000 + 1;
	};
	/** Rejestruje dwik. */
	inline void SoundRegister(cCtrl * Ctrl , const char * name , const char * info , int flags = 0 , int colID=-1) {
		sIMessage_SoundRegister sr(name , info , flags , colID);
		Ctrl->IMessage(&sr);
	}
	/** Odgrywa dwik */
	inline void SoundPlay(cCtrl * Ctrl , const char * name , int cntID=0) {
		Ctrl->IMessage(&sIMessage_2params(PLAY , NET_SOUND , IMT_CONFIG , (int)name , cntID));
	}
};


/// @}