/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: SMS
 * Modyfikowany: 2004-09-27
 * Zgodny z wersj: 
 * Info: Nagwek wtyczki SMS.
 * Autor: Stamina
 * 
 * rodowisko: Borland C++ i MS Visual C++
 * 
 * http://www.stamina.eu.org/konnekt/sdk/
 * 
 * (C)2002-2003 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */


#pragma once
/**
@file 
Nagwek wtyczki SMS.
eby wysa wiadomo sms naley wstawi do kolejki wiadomoci, lub wysa
bezporednio do wtyczki komunikatem #IM_MSG_SEND wiadomo:
@code
    cMessage m;
    m.net = Sms::net;
    m.type = MT_SMS;
    m.fromUid = "";
    m.body = "TRE WIADOMOCI";
    m.toUid = "DOCELOWY NUMER";
    m.flag = MF_SEND;
    m.time = _time64(0);
	std::string ext;
	// W EXT ustawiamy parametry wysyania:
	ext = SetExtParam(ext, Sms::extFrom, "PODPIS WYSYAJCEGO"); // nie zawsze wymagany
	ext = SetExtParam(ext, Sms::extGate, "IDENTYFIKATOR BRAMKI");  // wymagany!
	// Jeeli NIE chcemy, eby wtyczka SMS dzielia wiadomo, ustawiamy parametr extPart...
	// ext = SetExtParam(ext, Sms::extPart, "0");
	
	m.ext = (char*) ext.c_str();

@endcode

*/

namespace Sms {
	const int net = NET_SMS;
	const char * extFrom = "SMSfrom";
	const char * extGate = "SMSgate";
	const char * extWindowID = "SMSwinID";
	const char * extPart = "SMSpart";
	namespace IM {
		/** Zwraca list bramek obsugujcych podany numer, ktr mona wypeni combobox (razem z opisami, bez ikon).
			@param p1 (const char *) numer telefonu do sprawdzenia
			@return (const char *) lista bramek
		*/
		const int getGatewaysComboText = IM_USER + 14001; 
		/** Zwraca limit znakw na wiadomo wybranej bramki
			@param p1 (const char *) identyfikator bramki
			@return (int) limit znakw
		*/
		const int getGatewayLimit = IM_USER + 14002; 
	};
};