/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: UI message controls
 * Modyfikowany: 2004-11-17
 * Zgodny z wersj: 
 * Info: Nagwek do obsugi kontrolek w oknach wiadomoci i historii
 * 
 * rodowisko: Borland C++ i MS Visual C++
 * 
 * http://www.stamina.eu.org/konnekt/sdk/
 * 
 * (C)2002-2003 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */

/** \file
    Nagwek do obsugi kontrolek w oknach wiadomoci i historii.

	W wersji UI 0.1.18 kontrolki obsugujce okno wiadomoci i histori
	zostay zmienione tak, aby byo moliwe ich zastpienie.
	Obie akcje uznawane s z gry za akcje typu #ACTT_HWND, niezalenie
	od ustawionego stylu. Za pozycjonowanie i rozmiar okna odpowiada
	sam interfejs. Komunikacja z interfejsem odbywa si poprzez
	specjalne komunikaty akcji opisane w tym pliku...
	Jedynym stylem (nowym w tym UI), ktry dobrze by byo doda 
	jest #ACTR_SETCNT.
	W programie mona podmieni 3 kontrolki, usuwajc istniejce
	przez #IMI_ACTION_REMOVE i tworzc w ich miejsce nowe o tym
	samym identyfikatorze...
	W oknie rozmowy:
	sUIAction(IMIG_MSGWND , konnekt::UI::act::msg_ctrlview)  -  podgld rozmowy
	sUIAction(IMIG_MSGWND , konnekt::UI::act::msg_ctrlsend)  -  wpisywanie treci
	W oknie historii:
	sUIAction(IMIG_HISTORYWND , konnekt::UI::act::msg_ctrlview)  -  podgld rozmowy

	Ukad namespace'w i nazwy staych i klas moe si jeszcze zmieni!
*/


namespace Konnekt {
	namespace UI {
		namespace ACT{
			const int msg_ctrlview = 250; ///< Kontrolka, w ktrej pojawiaj si wiadomoci
			const int msg_ctrlsend = 251; ///< Kontrolka, z ktrej wiadomoci s wysyane
			const int msg_ctrlsend_menu = 260; ///< Menu msg_ctrlsend
			const int msg_ctrlsend_menu_copy = 261;
			const int msg_ctrlsend_menu_paste = 262;
			const int msg_ctrlsend_menu_paste_nf = 263;
			const int msg_ctrlsend_menu_paste_qt = 264;
			const int msg_ctrlsend_menu_select = 265;
			const int msg_ctrlsend_menu_cut = 266;
			const int msg_ctrlsend_menu_delete = 267;
			const int msg_ctrlsend_menu_undo = 268;
			const int msg_ctrlsend_menu_redo = 269;
			const int msg_ctrlsend_menu_hist_previous = 270;
			const int msg_ctrlsend_menu_hist_next = 271;
			const int msg_ctrlsend_menu_hist_clear = 272;

		};
		namespace Notify {
			// kontrolka do wywietlania
			const int lock = 300;  ///< Odwieanie okna powinno by zablokowane
			const int unlock = 301; ///< Odwieanie okna powinno by przywrcone
			const int clear = 302; ///< Okno powinno by wyczyszczone
			const int insertMsg = 310; ///< Trzeba wstawi wiadomo (_insertMsg *)
			const int insertStatus = 311;  ///< Trzeba wstawi info o zmianie statusu (_insertStatus *)
			// kontrolka do wpisywania
			const int getMessage = 312;  ///< Trzeba wstawi tre wpisanej wiadomoci (dla kontrolek do pisania treci)
			const int getMessageSize = 313;  /**< Trzeba zwrci rozmiar wpisanej wiadomoci.*/

			const int getSelection = 314;  ///< Trzeba zwrci aktualne zaznaczenie (_getSelection *).
			const int getMessageLines = 315;  /**< Trzeba zwrci liczb linijek w wiadomoci.*/
			const int getMessageLine = 316;  /**< Trzeba zwrci numer linii, w ktrej znajduje si znak.
												@param notify1 (int)numer znaku
											 */
			const int supportsFormatting = 317;  ///< Czy kontrolka (wpisywania) obsuguje formatowanie
			const int setSelection = 318;  ///< Ustawia aktualne zaznaczenie (_setSelection *).
			const int insertText = 319;  ///< Ustawia aktualne zaznaczenie (_insertText *).
			class _insertMsg: public sUIActionNotify_base {
			public:
				cMessage * _message; ///< Wiadomo do wywietlenia
				const char * _display; ///< Nazwa kontaktu jako autora (jeeli "" - to na podstawie wiadomoci)
				bool _scroll; ///< Czy przewin ekran do dodanej wiadomoci
				_insertMsg(cMessage * message , const char * display , bool scroll):_message(message),_display(display),_scroll(scroll) 
					{code = insertMsg; s_size = sizeof(*this);}
			};
			class _insertStatus: public sUIActionNotify_base {
			public:
				int _status; ///< Status
				const char * _info; ///< Opis
				_insertStatus(int status , const char * info):_status(status),_info(info) {code = insertStatus; s_size = sizeof(*this);}
			};
			class _getMessage: public sUIActionNotify_base {
			public:
				cMessage * _message; ///< Wiadomo do wywietlenia. cMessage::body trzyma wskanik do bufora, ktrego rozmiar zosta ustawiony w getMessageSize
				int _size;
				_getMessage(cMessage * message , int size):_message(message),_size(size) 
				{code = getMessage; s_size = sizeof(*this);}
			};
			class _getSelection: public sUIActionNotify_base {
			public:
				int _start; ///< Pocztek zaznaczenia
				int _end; ///< Koniec zaznaczenia.
				_getSelection():sUIActionNotify_base(getSelection),_start(0),_end(0) {s_size = sizeof(*this);}
			};
			typedef _getSelection _setSelection;

			class _insertText: public sUIActionNotify_base {
			public:
				const char * _text; ///< Tre do wstawienia/zastpienia
				bool _isHtml; ///< Czy jest formatowana?
				int _position; ///< Miejsce do wklejenia. -1 - aktualna pozycja/zaznaczenie
				_insertText():sUIActionNotify_base(insertText),_text(""),_isHtml(false),_position(-1) {s_size = sizeof(*this);}
			};

		};
	};
};

#pragma once